from http.server import BaseHTTPRequestHandler,HTTPServer
import json
from urllib.parse import urlparse,  parse_qs
from multimeter import MR9803R
from powersupply import HM305P

class ServHandler(BaseHTTPRequestHandler):
    
    def __init__(self,  request, client_address, server):
        mhtml = open("main.htmgui", "r") 
        self.mainhtml = mhtml.read()
        self.jdict = {"multi_val": 0, "multi_mode": "", "multi_range": "", "power_outvolt":0, "power_outcurr":0, "power_outpow":0}
        super(ServHandler,  self).__init__(request, client_address, server)

    def do_GET(self):
        
        vfile = urlparse(self.path).path
        #print(vfile)

        if vfile == '/':
            self.send_response(200)
            self.send_header('Content-type','text/html')
            self.end_headers()
            self.wfile.write(self.mainhtml.encode())
            return

        if vfile == '/data.json':
            self.send_response(200)
            self.send_header('Content-type','application/json')
            self.end_headers()
            self.jdict["multi_val"] = multimeter.value
            self.jdict["multi_mode"] = multimeter.mode
            self.jdict["multi_range"] = multimeter.range
            self.jdict["power_outvolt"] = powersup.out_voltage
            self.jdict["power_outcurr"] = powersup.out_current
            self.wfile.write(json.dumps(self.jdict).encode())
            return
            
        if vfile == '/senddata.set':
            ovolt = parse_qs(urlparse(self.path).query).get('ovolt', None)
            if ovolt is not None:
                try:
                    outvolt = float(ovolt[0])
                    #print(outvolt)
                    
                    powersup.write_out_voltage(outvolt)
                    
                    self.send_response(303)
                    self.send_header('location','/')
                    self.end_headers()
                except:
                    print("HTTP Data recieve error")
            return


multimeter = MR9803R('/dev/ttyUSB_Multimeter')
multimeter.start()

powersup = HM305P('/dev/ttyUSB_Labornetzteil')
powersup.start()
 
server = HTTPServer(('0.0.0.0', 8080), ServHandler)
print("server started")
server.serve_forever()
