import serial
import threading

class MR9803R(threading.Thread):
    
    def __init__(self,  devicecom):
        self.con = serial.Serial(devicecom, 9200, timeout=1,bytesize=7, parity='N', stopbits=2)
        #self.quit = False
        self.digits = "0"
        self.mode = ""
        self.range = ""
        self.value = 0.0
        super(MR9803R, self).__init__()
        
    def read(self):
        try:
            
            data = self.con.readline()
            self.digits = str(data[4]) + str(data[3]) + str(data[2]) + str(data[1])
            self.value = float(self.digits)
            modebyte0 = int(data[5])
            modebyte1 = int(data[6])
            
            # DC V-
            if modebyte0 == 0:
                self.mode = "DC V-"
                
                if modebyte1 == 0:
                    self.range = "mV"
                    self.value = self.value / 10.0
                if modebyte1 == 1:
                    self.range = "V"
                    self.value = self.value / 1000.0
                if modebyte1 == 2:
                    self.range = "V"
                    self.value = self.value / 100.0
                if modebyte1 == 3:
                    self.range = "V"
                    self.value = self.value / 10.0
                if modebyte1 == 4:
                    self.range = "V"
            
            # AC V~
            if modebyte0 == 1:
                self.mode = "AC V~"
                
                if modebyte1 == 0:
                    self.range = "mV"
                    self.value = self.value / 10.0
                if modebyte1 == 1:
                    self.range = "V"
                    self.value = self.value / 1000.0
                if modebyte1 == 2:
                    self.range = "V"
                    self.value = self.value / 100.0
                if modebyte1 == 3:
                    self.range = "V"
                    self.value = self.value / 10.0
                if modebyte1 == 4:
                    self.range = "V"
            
            # DC mA
            if modebyte0 == 2:
                self.mode = "DC mA"
                
                if modebyte1 == 0:
                    self.range = "mA"
                    self.value = self.value / 1000.0
                if modebyte1 == 1:
                    self.range = "mA"
                    self.value = self.value / 100.0
                if modebyte1 == 2:
                    self.range = "mA"
                    self.value = self.value / 10.0
                    
            # AC mA
            if modebyte0 == 3:
                self.mode = "AC mA"
                
                if modebyte1 == 0:
                    self.range = "mA"
                    self.value = self.value / 1000.0
                if modebyte1 == 1:
                    self.range = "mA"
                    self.value = self.value / 100.0
                if modebyte1 == 2:
                    self.range = "mA"
                    self.value = self.value / 10.0
           
           # Ohm         
            if modebyte0 == 4:
                self.mode = "Ohm"
                
                if modebyte1 == 0:
                    self.range = "Ohm"
                    self.value = self.value / 10.0
                if modebyte1 == 1:
                    self.range = "kOhm"
                    self.value = self.value / 1000.0
                if modebyte1 == 2:
                    self.range = "kOhm"
                    self.value = self.value / 100.0
                if modebyte1 == 3:
                    self.range = "kOhm"
                    self.value = self.value / 10.0
                if modebyte1 == 4:
                    self.range = "kOhm"
                if modebyte1 == 5:
                    self.range = "MOhm"
                    self.value = self.value / 10.0
                    
            # DC A
            if modebyte0 == 8:
                self.mode = "DC A"
                self.value = self.value / 100.0
        
            # AC A
            if modebyte0 == 9:
                self.mode = "AC A"
                self.value = self.value / 100.0
            
            #print("digits: "+ self.digits)
            #print("value: "+ str(self.value))
            #print("mode: " + self.mode)
            #print("range: " + self.range)
            #print("----------")
            #print(str(data[6]))
        except:
            self.digits = "0"
            self.mode = ""
            self.range = ""
            self.value = 0.0
            #print("Multimeter recieve error!") 
            #self.quit = True
    
    def run(self):
        #while not self.quit:
        while self.is_alive():
            self.read()

