import minimalmodbus
import threading
import time

class HM305P(threading.Thread):
    
    def __init__(self,  devicecom):
        self.out_voltage = 0
        self.out_current = 0
        self.set_out_voltage = 0
        try:
            self.instrument = minimalmodbus.Instrument(devicecom, 1) 
            self.instrument.serial.baudrate = 9600
            self.instrument.serial.timeout = 1
        except:
            print("Error: Could not connect to Power Supply")
        super(HM305P, self).__init__()
        
    def read_out_voltage(self):
        try:
            val = self.instrument.read_register(16, 1) / 10
            val = round(val,  2)
            #print(val)
        except:
            val = 0
        return val
        
    def read_out_current(self):
        try:
            val = self.instrument.read_register(17, 1)
            val = round(val,  2)
            #print(val)
        except:
            val = 0
        return val
        
    def write_out_voltage(self,  value):
        try:
            self.instrument.write_register(1, 0,  1) # SWITCH OUTPUT OFF FIRST !!!
            value = int(value * 10)
            self.instrument.write_register(48, value,  1)
            print("Setting Output Voltage to: " + str(value))
        except:
            print("Error setting Voltage")

    def run(self):
        while self.is_alive():
            self.out_voltage = self.read_out_voltage()
            self.out_current = self.read_out_current()
            time.sleep(0.5)
